//+------------------------------------------------------------------+
//|                                           Sample_SOM_Net_Img.mq5 |
//|                                            Copyright 2015, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
#property version   "1.00"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#include "Include\\SOM_Net_Img.mqh"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//---  ,       
input string SOM_Net="SOM\\SOM_Net";
//---  ,    
input string DataFileName="SOM\\optim.csv";
//---  ,    
input int Iteration=10000;
//---  ,     X
input int CellsX=50;
//---  ,     Y
input int CellsY=50;
//---  ,      
input bool HexagonalCell=false;
//---  ,    
input bool ShowBorders=false;
//---  ,      
input bool ShowTitles=false;
//---  ,     BMP-
input bool SaveFiles=true;
//---  ,    
input ColorSchemes ColorScheme=Blue_Green_Red;
//---  ,  . -   
input int MaxPictures=4;
//---  ,   
input int ImageXSize=250;
//---  ,   
input int ImageYSize=250;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CSOM_Net_Img som;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---      SOM\\optim.csv  
   if(som.LoadPatternDataFromFile(DataFileName))
     {
      //---    
      som.InitParameters(Iteration,CellsX,CellsY,ImageXSize,ImageYSize,HexagonalCell,ShowBorders,ShowTitles,ColorScheme,MaxPictures);
      //---   
      som.Train();
      //---         
      som.Render();
      //---  bmp
      som.ShowBMP(false);
      //---  true,   bmp-  
      if(SaveFiles)som.SaveBMP();
      //---    
      som.SaveNet(SOM_Net);
      //---      
      double vector[];
      //---      
      for(int PTRN=0; PTRN<som.GetTotalsPatterns() && !IsStopped(); PTRN++)
        {
         //---    PTRN (  )   vector[]
         if(som.GetPatterns(PTRN,vector))
           {
            //---      
            int ND=som.BestMatchingNode(vector);
            //---       
            som.GetNode(ND);
            //---       
            string nod="best node ",vct="datavector";
            for(int i=0;i<som.GetDimension();i++)
              {
               //---     
               nod+="["+DoubleToString(som.public_node.GetWeight(i),2)+"]";
               //---   
               vct+="["+DoubleToString(vector[i],2)+"]";
              }
            //---
            Print(" ",som.GetTitlesPatterns(PTRN),":     =",ND,
                  "   = ",som.public_node.nX(),"x",som.public_node.nY()
                  );
            //---      
            Print(nod);
            //---    
            Print(vct);
            //---
            Sleep(10);
           }
        }
     }
   else Print("Expert       "+DataFileName);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---    
   som.NetDeinit();
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick(){}
//+------------------------------------------------------------------+
